@use "bootstrap";

body {
  font-family: var(--font-default);
  font-weight: 600;
  color: var(--color-dark);
  line-height: 1.22;
  padding: 6.4rem 16.67vw calc(6.4rem + env(safe-area-inset-bottom));

  @include bootstrap.respond-to-small-screen {
    padding: 3.2rem 1.2rem calc(3.2rem + env(safe-area-inset-bottom));
  }
}

.heading {
  font-size: 3.6rem;
  margin-bottom: 5rem;

  @include bootstrap.respond-to-small-screen {
    font-size: 2.4rem;
    margin-bottom: 2rem;
  }
}

.checkout {
  display: flex;
  flex-direction: row-reverse;
  align-items: flex-start;
  gap: 7.78vw;

  @include bootstrap.respond-to-small-screen {
    flex-direction: column;
    align-items: stretch;
    gap: 4rem;
  }
}

.order {
  width: 38.3rem;
  flex: 0 0 auto;
  background-color: var(--color-grey-lighter);
  padding: 3.6rem 3rem 2.4rem;
  border-radius: 1.2rem;
  display: flex;
  flex-direction: column;
  gap: 9.6rem;

  @include bootstrap.respond-to-small-screen {
    width: 100%;
    padding: 3rem 2.5rem 2rem;
    border-radius: 1.2rem;
    gap: 8.6rem;
  }

  &__entries {
    display: flex;
    flex-direction: column;
    gap: 3.2rem;

    @include bootstrap.respond-to-small-screen {
      align-items: center;
      gap: 2.8rem;
    }
  }

  &__entry {
    display: grid;
    grid-template:
      "image title" 2rem
      "image empty-space-1" 0.8rem
      "image prices" 2rem
      "image empty-space-2" 3.7rem
      "image quantity" 5.2rem
      / 13.5rem max-content;
    column-gap: 2rem;

    @include bootstrap.respond-to-small-screen {
      grid-template:
        "image title" 2rem
        "image empty-space-1" 0.7rem
        "image prices" 2rem
        "image empty-space-2" 2.6rem
        "image quantity" 5.2rem
        / 12.5rem max-content;
      column-gap: 2rem;
    }
  }

  &__entry-image {
    grid-area: image;
    width: 100%;
    height: 100%;
    object-fit: cover;
    object-position: center;
    border-radius: 1.2rem;
  }

  &__entry-title {
    grid-area: title;
    font-size: 1.6rem;
    display: grid;
    align-content: center;

    @include bootstrap.respond-to-small-screen {
      font-size: 1.2rem;
    }
  }

  &__entry-prices {
    grid-area: prices;
    height: 100%;
    display: grid;
    align-content: center;
    align-items: center;
    grid-template-columns: max-content max-content;
    gap: 1.2rem;
  }

  &__entry-price {
    &--original {
      font-size: 1.2rem;
      text-decoration: line-through;

      @include bootstrap.respond-to-small-screen {
        font-size: 1rem;
      }
    }

    &--discounted {
      font-size: 1.6rem;
      color: var(--color-primary);

      @include bootstrap.respond-to-small-screen {
        font-size: 1.2rem;
      }
    }
  }

  &__entry-quantity-field {
    width: 13.5rem;
    grid-area: quantity;
    border: solid 0.1rem var(--color-grey-dark);
    border-radius: 1.2rem;
    padding: 1.45rem 1.2rem;
    display: flex;
    justify-content: space-between;

    @include bootstrap.respond-to-small-screen {
      padding: 1.45rem 1rem;
    }
  }

  &__entry-quantity {
    font-size: 1.6rem;
  }

  &__entry-control {
    position: relative;
    background-color: var(--color-grey-light);
    width: 2.1rem;
    height: 2.1rem;
    border-radius: 0.4rem;
    outline: 0.2rem solid transparent;
    transition: outline 0.125s ease-in;

    &:hover,
    &:focus,
    &:active {
      outline: 0.2em solid var(--color-grey-dark);
    }

    & .icon {
      position: absolute;
      width: 100%;
      height: 100%;
      left: 0;
      top: 0;
    }

    &--decrement {
      order: -1;
    }
  }

  &__costs-item {
    height: 4rem;
    width: 100%;
    display: grid;
    grid-template-columns: repeat(2, max-content);
    align-content: center;
    justify-content: space-between;
    border-top: solid 0.1rem var(--color-grey-medium);
  }

  &__cost-title {
    font-size: 1.8rem;
    display: grid;
    align-content: center;

    @include bootstrap.respond-to-small-screen {
      font-size: 1.4rem;
    }
  }

  &__cost-value {
    font-size: 1.4rem;
    display: grid;
    align-content: center;
  }
}

.form {
  width: 100%;
  display: flex;
  flex-direction: column;
  align-items: flex-start;

  &__sections {
    display: flex;
    flex-direction: column;
    gap: 4rem;

    @include bootstrap.respond-to-small-screen {
      gap: 3rem;
    }
  }

  &__section-heading {
    font-size: 1.8rem;
    margin-bottom: 1.5rem;

    @include bootstrap.respond-to-small-screen {
      font-size: 1.4rem;
      margin-bottom: 1.1rem;
    }
  }

  &__field {
    margin-bottom: 2rem;

    @include bootstrap.respond-to-small-screen {
      margin-bottom: 1.6rem;
    }

    &--input,
    &--select,
    &--textarea {
      display: grid;
      grid-template-columns: 4.8rem 1fr 4.8rem;
      row-gap: 0.7rem;

      @include bootstrap.respond-to-small-screen {
        grid-template-columns: 3.8rem 1fr 3.8rem;
        row-gap: 0.5rem;
      }
    }

    &--input,
    &--select {
      grid-template-rows: auto 5.6rem;
      align-items: center;

      @include bootstrap.respond-to-small-screen {
        grid-template-rows: auto 4rem;
      }
    }

    &--textarea {
      grid-template-rows: auto minmax(5.6rem, auto);

      @include bootstrap.respond-to-small-screen {
        grid-template-rows: auto minmax(4rem, auto);
      }
    }

    &--checkbox {
      display: flex;
      gap: 1.2rem;
      align-items: center;

      @include bootstrap.respond-to-small-screen {
        gap: 0.8rem;
      }
    }
  }

  &__label {
    font-size: 1.2rem;
    color: var(--color-grey-darker);
    align-self: end;

    @include bootstrap.respond-to-small-screen {
      font-size: 1rem;
    }

    &--input,
    &--select,
    &--textarea {
      grid-column: 1 / -1;
      grid-row: 1 / span 1;
    }

    &--checkbox {
      align-self: center;
    }
  }

  &__icon {
    &--input,
    &--select,
    &--textarea,
    &--select-dropdown {
      grid-row: 2 / span 1;
      justify-self: center;
    }

    &--input,
    &--select,
    &--textarea {
      grid-column: 1 / span 1;
    }

    &--textarea {
      margin-top: 1.6rem;

      @include bootstrap.respond-to-small-screen {
        margin-top: 1.1rem;
      }
    }

    &--select-dropdown {
      grid-column: 3 / span 1;
      height: 2.1rem;
      width: 2.1rem;
      background-color: var(--color-grey-light);
      padding-top: 0.1rem;
      border-radius: 0.4rem;

      @include bootstrap.respond-to-small-screen {
        height: 1.5rem;
        width: 1.5rem;
      }
    }
  }

  &__control {
    &:not(&--checkbox) {
      font-size: 1.6rem;
      height: 100%;
      width: 100%;
      border: 0.1rem solid var(--color-grey-dark);
      border-radius: 1.2rem;
      grid-column: 1 / -1;
      grid-row: 2 / span 1;
      transition: border 0.125s ease-in;

      @include bootstrap.respond-to-small-screen {
        font-size: 1.2rem;
      }

      // For iOS only
      @supports (-webkit-touch-callout: none) {
        font-size: max(16px, 1.6rem);

        @include bootstrap.respond-to-small-screen {
          font-size: max(16px, 1.2rem);
        }
      }

      &:focus {
        border: 0.4rem solid var(--color-grey-dark);
      }
    }

    &--input,
    &--select {
      display: flex;
      align-items: center;
    }

    &--input {
      padding-left: 5.2rem;
      padding-right: 1.2rem;

      @include bootstrap.respond-to-small-screen {
        padding-left: 4rem;
        padding-right: 1.2rem;
      }
    }

    &--textarea {
      resize: vertical;
      word-wrap: break-word;
      align-self: center;
      padding: 1.8rem 1.2rem 1.8rem 5.2rem;

      @include bootstrap.respond-to-small-screen {
        padding: 1.2rem 1.2rem 1.2rem 4rem;
      }
    }

    &--input,
    &--textarea {
      &::placeholder {
        opacity: 1;
        color: var(--color-grey-dark);
      }
    }

    &--select {
      padding-left: 5.2rem;
      padding-right: 5.2rem;
      overflow-x: scroll;
      cursor: pointer;
      z-index: 100; // so that it is clickable when arrow icon is clicked

      @include bootstrap.respond-to-small-screen {
        padding-left: 4rem;
        padding-right: 4rem;
      }

      &:invalid {
        color: var(--color-grey-dark);
      }

      & option {
        color: var(--color-dark);
      }
    }

    &--checkbox {
      order: -1;
      border: 0.1rem solid var(--color-grey-dark);
      border-radius: 0.4rem;
      width: 2.1rem;
      height: 2.1rem;
      flex: 0 0 auto;
      outline: 0.3rem solid transparent;
      outline-offset: 0.2rem;
      transition: outline 0.125s ease-in;

      @include bootstrap.respond-to-small-screen {
        width: 1.5rem;
        height: 1.5rem;
        outline: 0.2rem solid transparent;
        outline-offset: 0;
      }

      &:checked {
        display: grid;
        place-content: center;
      }

      &::before {
        content: "";
        width: 1.2rem;
        height: 1.2rem;
        transform: scale(0);
        transition: transform 120ms ease-in;
        box-shadow: inset 1rem 1rem currentcolor;
        background-color: canvastext;
        transform-origin: bottom left;
        clip-path: polygon(14% 44%, 0 65%, 50% 100%, 100% 16%, 80% 0%, 43% 62%);

        @include bootstrap.respond-to-small-screen {
          width: 0.8rem;
          height: 0.8rem;
        }
      }

      &:checked::before {
        transform: scale(1);
      }

      &:focus-visible {
        outline: 0.3rem solid var(--color-grey-dark);

        @include bootstrap.respond-to-small-screen {
          outline: 0.2rem solid var(--color-grey-dark);
        }
      }
    }
  }

  &__validation {
    font-size: 1.4rem;
    color: var(--color-error);
    grid-column: 1 / -1;
    width: 100%;

    @include bootstrap.respond-to-small-screen {
      font-size: 1.1rem;
    }
  }

  &__btn {
    width: 16.6rem;
    height: 5.4rem;
    align-self: flex-end;
    border: 0.5rem solid transparent;
    margin-bottom: 2rem;
    transition: border 0.125s ease-in;

    @include bootstrap.respond-to-small-screen {
      margin-bottom: 1.6rem;
    }

    &:hover,
    &:focus,
    &:active {
      border: 0.5rem solid var(--color-grey-dark);
    }
  }

  &__shipping-address {
    display: grid;
    grid-template-columns: 1fr 1fr;
    grid-template-rows: repeat(5, auto);
    column-gap: 3rem;

    @include bootstrap.respond-to-small-screen {
      column-gap: 2.4rem;
    }

    & #form__field--country {
      grid-column: 1 / span 1;
    }

    & #form__field--postal-code {
      grid-column: 2 / span 1;
    }

    & > :not(:nth-child(5) :nth-child(6)) {
      grid-column: 1 / -1;
    }
  }
}

.results {
  font-size: 1.8rem;
  color: var(--color-success);
  visibility: hidden; // this is initial state

  @include bootstrap.respond-to-small-screen {
    font-size: 1.4rem;
  }

  &--hidden {
    position: absolute;
    opacity: 0;
  }

  &--shown {
    position: unset;
    opacity: 1;
    transition: opacity 0.1s ease-in;
  }
}
